package com.project.contact;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Vector;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class MailTo extends Activity implements OnClickListener{
	EditText text;
	EditText subject;
	Button send;
	Button cancel;
	ProgressDialog pd;
	
	Boolean returnStatus = false;
	Handler handler = new Handler();
	Thread thread;
	Toast toast;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mailto);
        
        text = (EditText)findViewById(R.id.text);
        subject = (EditText)findViewById(R.id.subject);
        send = (Button)findViewById(R.id.send);
        cancel = (Button)findViewById(R.id.cancel);
        
        
        toast = Toast.makeText(this,"",Toast.LENGTH_SHORT);
        send.setOnClickListener(this);
        cancel.setOnClickListener(this);
        
        pd = new ProgressDialog(this);
        pd.setMessage("Sending..");
        thread = new Thread(null,DoMail,"Mailing");
    }
    
    private Runnable DoMail = new Runnable(){
    	public void run(){
    		handler.post(UpdateUI);
    		Mailing();
    		handler.post(UpdateUI);
    	}
    };
    private Runnable UpdateUI = new Runnable(){
    	public void run(){
    		if(pd.isShowing()){
    			pd.dismiss();
    			if(returnStatus){
    				toast.setText("Operation successful");
    				toast.show();
    			}
    			else{
    				toast.setText("Operation unsuccessful");
    				toast.show();
    			}
    		}
    		else pd.show();
    	}
    };
    public void Mailing(){
    	String urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/object.asp?method=MESSENGER_SEND_EMAIL&";
    	Vector<NameValuePair> vars = new Vector<NameValuePair>();
    	vars.add(new BasicNameValuePair("select",ViewInfo.conta.GetId()));
    	vars.add(new BasicNameValuePair("subject",subject.getText().toString()));
    	vars.add(new BasicNameValuePair("message",text.getText().toString()));
    	
    	HttpGet method;
    	BufferedReader in = null;

    	try {
    		URI url = new URI(urlstr + URLEncodedUtils.format(vars,null));
    		HttpClient client = new DefaultHttpClient();
    		method = new HttpGet(url);
    		
    		HttpResponse response = client.execute(method);
    		in = new BufferedReader 
				(new InputStreamReader(response.getEntity().getContent() ));
    		//TODO: retrieve the response and prompt user via Toast
    		String str="";
    		while(in.readLine()==null){
    			str+=in.readLine();
    			if(str.substring(0, 1).equals("OK"))
    				returnStatus = true;
    		}
    	}catch(ClientProtocolException e){
    		Log.e("ClientProtocolException","Error Occured in fetching videos!" + e.getMessage());
    		e.printStackTrace();
    	}catch(IOException e){
    		Log.e("IOException","Error Occured in fetching videos!"+ e.getMessage());
    		e.printStackTrace();
    	}catch(URISyntaxException e){
    		Log.e("URISyntaxException","Error Occured in fetching videos!"+ e.getMessage());
    		e.printStackTrace();
    	}
    }

	public void onClick(View arg0) {
		if(arg0==send){
			pd = new ProgressDialog(this);
	        pd.setMessage("Sending..");
	        thread = new Thread(null,DoMail,"Mailing");
			thread.start();
		}
		else this.finish();
	}
}
