package com.project.contact;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity implements OnClickListener,OnCheckedChangeListener{
	Button login;
	Button cancel;
	ProgressDialog dialog;
	ProgressDialog dialog2;
	TextView status;
	EditText user;
	EditText pass;
	CheckBox cb;
	
	SharedPreferences sp;
	String Prefs_name = "Contacts";
	Thread th;
	Handler handler = new Handler();
	public static String sid="";
	String username = "";
	String password = "";	
	UsefulFuncs uf;
	public static ContactList cont;
	Boolean first = false;
	Toast toast;
	int loginstatus = 0;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        login = (Button)findViewById(R.id.login);
        cancel = (Button)findViewById(R.id.cancel);
        
        status = (TextView)findViewById(R.id.status);
        user = (EditText)findViewById(R.id.user);
        pass = (EditText)findViewById(R.id.pass);
        cb = (CheckBox)findViewById(R.id.cb);
        
        dialog = new ProgressDialog(this);
        dialog.setMessage("Loging in..");
        
        dialog2 = new ProgressDialog(this);
        dialog2.setMessage("Loading, please wait..");
        
        sp = getSharedPreferences(Prefs_name,0);
        username = sp.getString(Prefs_name, "");
        if(!username.equals("")) {
        	user.setText(username);
        	cb.setChecked(true);
        }
        cb.setOnCheckedChangeListener(this);
        cont = new ContactList();
        login.setOnClickListener(this);
        cancel.setOnClickListener(this);
        th = new Thread(null,Login,"Login");
        toast = Toast.makeText(this, "",Toast.LENGTH_SHORT);
    }
    
    private Runnable Login = new Runnable(){
    	public void run(){
    		handler.post(UpdateUI);
    		//check login retrieve status
    		LoginFunc();
    		if(sid.equals("")){
    			handler.post(UpdateUI);
    			loginstatus = 0;
    		}
    		else{
    			//proceed to new activity
    			loginstatus = 1;
				handler.post(UpdateUI);
				handler.post(UpdateUI2);
				uf = new UsefulFuncs();
				Intent intent = new Intent(getApplicationContext(),Screen1.class);
				cont = uf.DownloadContacts(false,sid);
				first = true;
				Bundle b =new Bundle();
				b.putParcelable("Contacts", cont);
				intent.putExtras(b);
				handler.post(UpdateUI2);
				startActivity(intent);
			} 
    			
    	}
    };
    private Runnable UpdateUI = new Runnable(){
    	public void run(){
    		if(dialog.isShowing()){
    			dialog.dismiss();
    			//error occured prompt user
    			if(loginstatus==0){
	    			toast.setText("Login failed, try again..");
	    			toast.show();
    			}
    			else if (loginstatus==1){
    				toast.setText("Login successful");
	    			toast.show();
	    		}
    		}
    		else dialog.show();
    	}
    };
    private Runnable UpdateUI2 = new Runnable(){
    	public void run(){
    		if(dialog2.isShowing())dialog2.dismiss();
    		else dialog2.show();
    	}
    };
    
    @Override
    public void onResume(){
    	if(first)
    		this.finish();
    	super.onResume();
    }
    @Override
    public void onPause(){
    	//this.finish();
    	super.onPause();
    }
	
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		if(arg0==login){
			//Intent intent = new Intent(this,Screen1.class);
			//startActivity(intent);
			username = user.getText().toString();
			password = pass.getText().toString();
			th = new Thread(null,Login,"Login");
			th.start();
		}
		else this.finish();
		
	}
	
	public void LoginFunc(){
		String str = "";
		String urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/logon.asp?logon="; 
		//"https://secure.mydigitalspacelive.com/directory/ondemand/logon.asp?logon=";
		String pass = "&password=";
		
		
		HttpGet method;
	
		BufferedReader in = null;
		
		try {

			URI url = new URI(urlstr + username + pass + password);
			HttpClient client = new DefaultHttpClient();
			method = new HttpGet(url);
			
			HttpResponse response = client.execute(method);
			in = new BufferedReader 
					(new InputStreamReader(response.getEntity().getContent() ));
			String temp;
			while((temp=in.readLine())!=null){
				str+=temp;
				Log.d("Check", "str processing...");
			}
			Log.d("Check", "str processed");
			if(str.equals("OK|NO|LOGONFAILED")){
				//Logon Failed
				sid="";
			}
			else {
				//logon successful store sid
				sid = RetrieveSid(str.substring(5));
			}
			} catch(ClientProtocolException e){
			// TODO Auto-generated catch block
			Log.e("ClientProtocolException","Error Occured in connecting to webservices!" + e.getMessage());
			e.printStackTrace();
			}catch(IOException e){
			// TODO Auto-generated catch block
			Log.e("IOException","Error Occured in connecting to webservices!"+ e.getMessage());
			e.printStackTrace();
			}
			catch(URISyntaxException e){
			// TODO Auto-generated catch block
				Log.e("URISyntaxException","Error Occured in connecting to webservices!"+ e.getMessage());
			e.printStackTrace();
			}
	}
	public String RetrieveSid(String str){
		char[] ch = str.toCharArray();
		StringBuilder sb = new StringBuilder();
		for(int lv=0;lv<str.length();lv++){
			if (ch[lv]!='|')sb.append(ch[lv]);
			else break;
		}
		return sb.toString();
	}
	public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
		// TODO Store username and password in SharedPreferences
		SharedPreferences.Editor spe = sp.edit();
		if (arg1){
			spe.putString(Prefs_name, user.getText().toString());
		}
		else spe.putString(Prefs_name, "");
		spe.commit();
	}
	
}
