package com.project.contact;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Vector;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class NewContact extends Activity implements OnClickListener{
	EditText fname;
	EditText lname;
	EditText mobile;
	EditText phone;
	EditText email;
	EditText address;
	EditText suburb;
	EditText state;
	EditText code;
	EditText country;
	
	Button add;
	Button cancel;
	
	String fn;
	String ln;
	String em;
	String mo;
	String pn;
	String ad;
	String st;
	String cd;
	String cn;
	String sb;
	Thread thread;
	Handler handler = new Handler();
	ProgressDialog pd;
	Toast toast;
	Boolean status = false;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.newcontact);
        
        
        fname = (EditText)findViewById(R.id.fname);
        lname = (EditText)findViewById(R.id.lname);
        mobile = (EditText)findViewById(R.id.mobile);
        phone = (EditText)findViewById(R.id.phone);
        email = (EditText)findViewById(R.id.email);
        address = (EditText)findViewById(R.id.address);
        suburb = (EditText)findViewById(R.id.suburb);
        state = (EditText)findViewById(R.id.state);
        code = (EditText)findViewById(R.id.code);
        country = (EditText)findViewById(R.id.country);
        
        add = (Button)findViewById(R.id.add);
        cancel = (Button)findViewById(R.id.cancel);
        
        add.setOnClickListener(this);
        cancel.setOnClickListener(this);
        
        pd = new ProgressDialog(this);
        pd.setMessage("Please wait..");
        
        toast = Toast.makeText(this,"",Toast.LENGTH_SHORT);
    }
    
    
	
	
	private Runnable AddContact = new Runnable(){
		public void run(){
			handler.post(UpdateUI);
			AddNewContact();
			handler.post(UpdateUI);
		}
	};
	private Runnable UpdateUI = new Runnable(){
		public void run(){
			if(pd.isShowing()){
				if(status)toast.setText("New Contact added successfully!");
				else toast.setText("Try again later!");
				toast.show();
				pd.dismiss();
			}
			else pd.show();
		}
	};
	
	public void AddNewContact(){
		String urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/object.asp?method=PERSON_ADD&"; 
				//"https://secure.mydigitalspacelive.com/directory/ondemand/logon.asp?logon=";
		Vector<NameValuePair> vars = new Vector<NameValuePair>();
		vars.add(new BasicNameValuePair("sid",MainActivity.sid));
		vars.add(new BasicNameValuePair("firstname",fn));
		vars.add(new BasicNameValuePair("surname",ln));
		vars.add(new BasicNameValuePair("phone",pn));
		vars.add(new BasicNameValuePair("mobile",mo));
		vars.add(new BasicNameValuePair("email",em));
		vars.add(new BasicNameValuePair("streetaddress1",ad));
		vars.add(new BasicNameValuePair("streetsuburb",sb));
		vars.add(new BasicNameValuePair("streetstate",st));
		vars.add(new BasicNameValuePair("streetpostcode",cd));
		vars.add(new BasicNameValuePair("streetcountry",cn));
		
		HttpGet method;
		BufferedReader in = null;
		
		try {
			URI url = new URI(urlstr + URLEncodedUtils.format(vars,null));
			HttpClient client = new DefaultHttpClient();
			method = new HttpGet(url);
			
			HttpResponse response = client.execute(method);
			in = new BufferedReader 
					(new InputStreamReader(response.getEntity().getContent() ));
			
			//TODO: retrieve the response and prompt user with toast
			String str="";
    		while(in.readLine()==null){
    			str+=in.readLine();
    			if(str.substring(0, 1).equals("OK"))
    				status = true;
    		}
			}catch(ClientProtocolException e){
				Log.e("ClientProtocolException","Error Occured in fetching videos!" + e.getMessage());
				e.printStackTrace();
			}catch(IOException e){
				Log.e("IOException","Error Occured in fetching videos!"+ e.getMessage());
				e.printStackTrace();
			}catch(URISyntaxException e){
				Log.e("URISyntaxException","Error Occured in fetching videos!"+ e.getMessage());
				e.printStackTrace();
			}
	}
	


	
	public void onClick(View v) {
		if(v==add){
			fn = fname.getText().toString();
			ln = lname.getText().toString();
			em = email.getText().toString();
			mo = mobile.getText().toString();
			pn = phone.getText().toString();
			ad = address.getText().toString();
			st = state.getText().toString();
			cd = code.getText().toString();
			cn = country.getText().toString();
			sb = suburb.getText().toString();
			
			Contact fk = new Contact("",fn,ln,mo,pn,em,ad,sb,st,cd,cn);
			Screen1.contacts.add(fk);
			Thread thread = new Thread(null,AddContact,"Add_Contact");
			thread.start();
		}
		else 
			this.finish();
	}
}
