package com.project.contact;

import java.util.ArrayList;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class Search extends ListActivity implements OnItemClickListener,OnClickListener{
	Button cancel;
	
	Thread th_search;
	Handler handler = new Handler();
	ProgressDialog dialog;
	UsefulFuncs uf;
	String name;
	EditText etxt;
	ContactAdapter ca;
	public static ArrayList<Contact> arr;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
        setContentView(R.layout.search);
        
        cancel = (Button)findViewById(R.id.cancel);
        etxt = (EditText)findViewById(R.id.searchetxt);
        uf = new UsefulFuncs();
        dialog = new ProgressDialog(this);
        
        cancel.setOnClickListener(this);
        arr = new ArrayList<Contact>();
        //arr.add(new Contact("Hassan","","","","","","","","",""));
        ca = new ContactAdapter(this,R.layout.row,arr);
    	setListAdapter(ca);
    }
    
    @Override
    public void onStart(){
    	
    	th_search = new Thread(null,SearchIt,"Search");
    	super.onStart();
    }
    
    private Runnable SearchIt = new Runnable(){
    	public void run(){
    		handler.post(UpdateUI);
    		//Connect to webservice parse the responses
    		arr = uf.Search(name,MainActivity.sid);
    		handler.post(Populate);
    		handler.post(UpdateUI);
    	}
    };
    private Runnable UpdateUI = new Runnable(){
    	public void run(){
    		if(dialog.isShowing()){
    			dialog.dismiss();
    			
    			//setListAdapter(this,R.layout.row,ca1);
    			//onStart();
    		}
    		else dialog.show();
    	}
    };
    private Runnable Populate = new Runnable(){
    	public void run(){
    		
        	SetList();
    	}
    };
    public void SetList(){
    	ca = new ContactAdapter(this,R.layout.row,arr);
    	setListAdapter(ca);
    }
    
    public void Serch(View v){
    	name = etxt.getText().toString();
    	th_search = new Thread(null,SearchIt,"Background");
    	th_search.start();
    }
    private class ContactAdapter extends ArrayAdapter<Contact>{
    	ArrayList<Contact> items;
    	int layout;
    	TextView tfname;
    	TextView tlname;
		public ContactAdapter(Context context, int textViewResourceId,
				ArrayList<Contact> objects) {
			super(context, textViewResourceId, objects);
			// TODO Auto-generated constructor stub
			items = objects;
			layout = textViewResourceId;
		}
		@Override
		public View getView(int position,View convertView,ViewGroup parentView){
			if(convertView == null){
				LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = li.inflate(layout, null);
			}
			tfname = (TextView)convertView.findViewById(R.id.fnametxt);
			tlname = (TextView)convertView.findViewById(R.id.lnametxt);
			
			tfname.setText(items.get(position).GetFname());
			tlname.setText("  " + items.get(position).GetLname());
			return convertView;
		}
    	
    }
	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		// TODO Auto-generated method stub
		Bundle b = new Bundle();
		ContactList cl = new ContactList();
		cl.add(arr.get(arg2));
		b.putParcelable("Contact", cl);
		Intent intent = new Intent(this,ViewInfo.class);
		intent.putExtras(b);
		startActivity(intent);
	}

	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		this.finish();
	}
}
